﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Airbus
{
    //класс для хранения коллекции карт
    internal class MapsCollection
    {
        //словарь (хранилище) с картами
        readonly Dictionary<string, MapWithSetPlanesGeneric<DrawningObjectPlane, AbstractMap>> _mapStorage;

        //возвращение списка названий карт
        public List<string> Keys => _mapStorage.Keys.ToList();

        //ширина окна отрисовки
        private readonly int _pictureWidth;

        //высота окна отрисовки
        private readonly int _pictureHeight;

        //конструктор
        public MapsCollection(int pictureWidth, int pictureHeight)
        {
            _mapStorage = new Dictionary<string, MapWithSetPlanesGeneric<DrawningObjectPlane, AbstractMap>>();
            _pictureWidth = pictureWidth;
            _pictureHeight = pictureHeight;
        }

        //добавление карты
        public void AddMap(string name, AbstractMap map)
        {
            var NewElem = new MapWithSetPlanesGeneric<DrawningObjectPlane, AbstractMap>(
            _pictureWidth, _pictureHeight, map);
            _mapStorage.Add(name, NewElem);
        }

        //удаление карты
        public void DelMap(string name)
        {
            _mapStorage.Remove(name);
        }

        //Доступ к аэродрому
        public MapWithSetPlanesGeneric<DrawningObjectPlane, AbstractMap> this[string ind]
        {
            get
            {
                return _mapStorage[ind];
            }
        }
    }
}
